// DefaultController object (handles commands when one of the trees does not have focus)
var PrevDel = {

   Verify_delete: function()
	{
		if( gFolderDisplay.selectedCount == 0 ) return;

		var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var tagService = Components.classes["@mozilla.org/messenger/tagservice;1"].getService(Components.interfaces.nsIMsgTagService);
		var gBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
		var Loctxt = gBundle.createBundle("chrome://PreventDelete/locale/PreventDelete.properties");
		let messages = [];
		let keepmes = [];
		
		var tagArray = tagService.getAllTags({});
		var doAlert = branch.getBoolPref( "extensions.preventdelete.alert" );
		var tagKey = branch.getCharPref( "extensions.preventdelete.etiquette" );
		var doWarn = branch.getBoolPref( "extensions.preventdelete.warning" );
		var tagName = tagService.getTagForKey(tagKey);
		var ApplyAll = {};
		ApplyAll.value = false;
		
		nbMsg = gFolderDisplay.selectedCount;
		for( var inc=0 ; inc < nbMsg ; inc++ )
		{
			var keyw = gFolderDisplay.selectedMessages[inc].getStringProperty("keywords");
			if( gFolderDisplay.selectedMessages[inc].getStringProperty("keywords").indexOf(tagKey) != -1 )
			{
			   if( !ApplyAll.value )
				{
					var AlertOK = 1;
					if( doAlert )
					{
						AlertOK = prompts.confirmEx(window, Loctxt.formatStringFromName("AlertForDelTit",[tagName],1), Loctxt.formatStringFromName("AlertForDel",[gFolderDisplay.selectedMessages[inc].mime2DecodedSubject],1),Components.interfaces.nsIPromptService.STD_YES_NO_BUTTONS,"","","", Loctxt.GetStringFromName("ApplyAll"),ApplyAll);
					}
				}
				if( AlertOK == 0 ) messages.push( gFolderDisplay.selectedMessages[inc] );
				else keepmes.push( gFolderDisplay.selectedMessages[inc] );
			}
			else
				messages.push( gFolderDisplay.selectedMessages[inc] );
		}

		if( doWarn )
		{
			if( messages.length == 0 )
			{
				if( nbMsg == 1 )
					var AlertOK = prompts.alert(window, Loctxt.GetStringFromName("WarnTitle"), Loctxt.formatStringFromName("WarnTheMess",[tagName],1));
				else
					var AlertOK = prompts.alert(window, Loctxt.GetStringFromName("WarnTitle"), Loctxt.formatStringFromName("WarnThoseMess",[tagName],1));				
			}
			else
			{
				if( nbMsg-messages.length == 1 )
					var AlertOK = prompts.alert(window, Loctxt.GetStringFromName("WarnTitle"), Loctxt.formatStringFromName("WarnOneMess",[tagName],1));
				else if( nbMsg-messages.length > 1 )
					var AlertOK = prompts.alert(window, Loctxt.GetStringFromName("WarnTitle"), Loctxt.formatStringFromName("WarnSomeMess",[nbMsg-messages.length,tagName],2));
			}		
		}			

		if( keepmes.length != 0 ) gFolderDisplay.clearSelection();
		
		if( messages.length == 0 ) return keepmes;

		if( keepmes.length != 0 )
		{
			old_ensure = gFolderDisplay.ensureRowRangeIsVisible;
			gFolderDisplay.ensureRowRangeIsVisible = function( min, max ) {};
			gFolderDisplay.selectMessages(messages);
			gFolderDisplay.ensureRowRangeIsVisible = old_ensure;
		}
		return keepmes;
	},
	
	init: function()
	{
		window.removeEventListener("load", PrevDel.init, false);
		window.addEventListener("unload", PrevDel.finish, false);
		
/*	   window.document.getElementById("cmd_delete").setAttribute("oncommand","PrevDel.Verify_delete();goDoCommand('cmd_delete')");
		window.document.getElementById("button-mark-deleted").setAttribute("oncommand","PrevDel.Verify_delete();goDoCommand(event.shiftKey ? 'cmd_shiftDelete' : 'cmd_delete')");
		window.document.getElementById("cmd_shiftDelete").setAttribute("oncommand","PrevDel.Verify_delete();goDoCommand('cmd_shiftDelete')");*/
		window.controllers.insertControllerAt(0,PrevDel.MyController);
		PrevDel.prefObserver.register();  // Listen for preferences changes
	},

	finish: function()
	{
		window.removeEventListener("unload", PrevDel.finish, false);
		PrevDel.prefObserver.unregister();
	},

   MyController:
	{
		supportsCommand : function(cmd)
		{ 
			switch ( cmd )
			{
				case "cmd_delete":
				case "cmd_shiftDelete":
				case "button_delete":
					return true;
				default:
					return false;
			}
		},
		isCommandEnabled : function(cmd)
		{ 
			switch ( cmd )
			{
				case "cmd_delete":
					UpdateDeleteCommand();
					// fall through
				case "button_delete":
					UpdateDeleteToolbarButton();
					return gFolderDisplay.getCommandStatus(nsMsgViewCommandType.deleteMsg);
				case "cmd_shiftDelete":
					return gFolderDisplay.getCommandStatus(nsMsgViewCommandType.deleteNoTrash);
				default:
					return false;
			}
		},
		doCommand : function(cmd)
		{ 
			let keepmes = PrevDel.Verify_delete();
			switch ( cmd )
			{			
				case "button_delete":
				case "cmd_delete":
					// if the user deletes a message before its mark as read timer goes off, we should mark it as read
					// this ensures that we clear the biff indicator from the system tray when the user deletes the new message
					MarkSelectedMessagesRead(true);
					// If this is a right-click triggered delete, then do not hint about
					//  the deletion.  Note: The code that swaps the selection back in will
					//  take care of ensuring that this deletion does not make the saved
					//  selection incorrect.
					if ((!gRightMouseButtonSavedSelection)&&( keepmes.length == 0))
						gFolderDisplay.hintAboutToDeleteMessages();
					gFolderDisplay.doCommand(nsMsgViewCommandType.deleteMsg);
					break;
				case "cmd_shiftDelete":
					MarkSelectedMessagesRead(true);
					if( keepmes.length == 0) gFolderDisplay.hintAboutToDeleteMessages();
					gFolderDisplay.doCommand(nsMsgViewCommandType.deleteNoTrash);
					break;
			}
			if( keepmes.length != 0 ) gFolderDisplay.selectMessages(keepmes);
		},
		onEvent : function(evt)
		{
		}
	},

	prefObserver:
	{
		_uninstall : false,
		observe : function(subject, topic, data) 
		{
			if (topic == "em-action-requested") 
			{
				subject.QueryInterface(Components.interfaces.nsIUpdateItem);

				if (subject.id == "PreventDelete@dischert.luc") 
				{
					if (data == "item-uninstalled") 
					{
						this._uninstall = true;
					} 
					else if (data == "item-cancel-action") 
					{
						this._uninstall = false;
					}
				}
			} 
			else if (topic == "quit-application-granted") 
			{
				if (this._uninstall) 
				{
					PrevDel.cleanupPrefs();             // Clear any pref entries from old versions
				}
				this.unregister();
			}
		},
		
		register : function() 
		{
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

			observerService.addObserver(this, "em-action-requested", false);
			observerService.addObserver(this, "quit-application-granted", false);
		},
		
		unregister : function() 
		{
			var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

			observerService.removeObserver(this,"em-action-requested");
			observerService.removeObserver(this,"quit-application-granted");
		}
	},

	cleanupPrefs: function()  // Wipes all PreventDelete preferences that do not have defaults
	{
		/* Both the user and default branches contain the exact same list of pref names,
		even if any default values don't exist or any user values equal the default. */
		var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
		var defaultBranch = prefService.getDefaultBranch("extensions.preventdelete.");
		var userBranch = prefService.getBranch("extensions.preventdelete.");
		var prefsList = userBranch.getChildList("",{});
		if (!prefsList.length)
			throw "Could not load PreventDelete preferences list";
		for (var i in prefsList)
		{   // Exception means no default exists and this pref is not in use
			try { defaultBranch.getBoolPref(prefsList[i]); }
			catch (e) { userBranch.clearUserPref(prefsList[i]); }
		}
	},
}

window.addEventListener("load", PrevDel.init, false);


